import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVellumDocumentIndexConfig extends cdktf.TerraformMetaArguments {
    /**
    * The Document Index's ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/document_index#id DataVellumDocumentIndex#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A name that uniquely identifies this index within its workspace
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/document_index#name DataVellumDocumentIndex#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/document_index vellum_document_index}
*/
export declare class DataVellumDocumentIndex extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vellum_document_index";
    /**
    * Generates CDKTF code for importing a DataVellumDocumentIndex resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVellumDocumentIndex to import
    * @param importFromId The id of the existing DataVellumDocumentIndex that should be imported. Refer to the {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/document_index#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVellumDocumentIndex to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/document_index vellum_document_index} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVellumDocumentIndexConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVellumDocumentIndexConfig);
    get created(): string;
    get environment(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get label(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get status(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
