import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataVellumMlModelConfig extends cdktf.TerraformMetaArguments {
    /**
    * The ML Model's ID
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/ml_model#id DataVellumMlModel#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * A name that uniquely identifies this ML Model
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/ml_model#name DataVellumMlModel#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/ml_model vellum_ml_model}
*/
export declare class DataVellumMlModel extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "vellum_ml_model";
    /**
    * Generates CDKTF code for importing a DataVellumMlModel resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataVellumMlModel to import
    * @param importFromId The id of the existing DataVellumMlModel that should be imported. Refer to the {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/ml_model#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataVellumMlModel to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/vellum-ai/vellum/0.0.7/docs/data-sources/ml_model vellum_ml_model} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataVellumMlModelConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataVellumMlModelConfig);
    get developedBy(): string;
    get family(): string;
    get hostedBy(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get visibility(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
